********************************************************************************
****                                 ****
********************************************************************************
* lcDBName -                                                      *
*              ,                     *
* lcOutFile -    (  )                  *
*               ,   "REIND_.prg"                      *
*   :                                                   *
*     1)     Close All,      *
*        , ..     ,      *
*        . (  ,     *
*           Close Databases All        *
*        )                                                               *
*                                                                              *
*     2)     "REIND_.prg",   *
*                 " "*
*         Close Databases All    .        *
*                                                                              *
*     3) ..       .dbc *
*         /,        . ..       *
*               .                  *
********************************************************************************
Function GenReind
  Lparameters lcDBName, lcOutFile
  Local lnColTabl &&     
  Local laTableName[1] &&   
  Local lnColRela &&      
  Local laRelaName[1] &&    
  Local lcTablePath &&    
  Local lnI, lnJ, lnT, lnTMax && 
  Local lnFHOut &&    
  Local lnOld_Text &&      SET TEXTMERGE
  Local lcTagName, lcTagType, lcTagOrder, lcTagKey, lcTagFor
  Local lcIndexExpr &&   
  Local lcOldTextmerge &&  
  Local lcOldTextmergeShow &&  
  Local lcOldPath &&  

  lcOldTextmerge= Set( "TEXTMERGE" )
  lcOldTextmergeShow= Set( "TEXTMERGE", 3 )
  lcOldPath= Fullpath( '' )
  Set Textmerge On Noshow

  #Define TERMOMETER_CYCLE  ;
  ****    ****<<Chr(13)+Chr(10)>> ;
pfrmTermometer.XpProgressBar.Curval=<<m.lnT>><<Chr(13)+Chr(10)>>

  lnT= 0 &&   
  lnTMax= 0 &&    

  If Type( 'm.lcDBName' ) <> 'C'
    lcDBName= Getfile( 'DBC', '   ...', 'OK', 0, '  ' )
    If Empty( m.lcDBName )
      Return
    Endif
  Else
    If Rat( '.', m.lcDBName )= 0
      lcDBName= Upper( m.lcDBName ) + '.DBC'
    Endif
    If File( m.lcDBName )
      lcDBName= Fullpath( m.lcDBName )
    Else
      Return
    Endif
  Endif
  If Type('m.lcOutFile')<>'C'
    lcOutFile= 'REIND_'+Strtran( Substr( m.lcDBName, Rat( '\', m.lcDBName ) + 1 ), '.DBC', '.PRG' )
  Endif
  lcOutFile= Alltrim(Upper( M.lcOutFile ))

  *     
  Cd ( Substr( m.lcDBName, 1, Rat( "\", m.lcDBName ) ) )

  *  
  lnFHOut= Fcreate( m.lcOutFile )
  If lnFHOut= -1
    Messagebox( '    "' + m.lcOutFile + '"' )
    Return
  Endif
  lnOld_Text= _Text
  _Text= lnFHOut


  *   
  Close Databases All
  Open Database ( m.lcDBName ) Exclusive Noupdate

  lnColTabl= Adbobjects( laTableName, 'TABLE' )
  lnColRela= Adbobjects( laRelaName, 'RELATION' )

  lnTMax= lnColTabl + lnColRela
  For lnI= 1 To m.lnColRela
    If ! Empty( laRelaName[lnI,5] )
      lnTMax= m.lnTMax + 1
    Endif
  Endfor


  *     
\\FUNCTION <<STRTRAN(IIF('\'$M.lcOutFile,SUBSTR(M.lcOutFile,RAT('\',M.lcOutFile)+1),M.lcOutFile),'.PRG','')>>
\PRIVATE pcOldTalk
\PRIVATE pcOldSafety
\PRIVATE pcOldNotify
\PRIVATE pcOldCollate
\PRIVATE pcOldCursor
\PRIVATE pcOldError
\PRIVATE pfrmTermometer
\LOCAL lnFH &&   
\LOCAL lnObjectID
\IF SET("TALK")="ON"
\  SET TALK OFF
\  pcOldTalk=.T.
\ELSE
\  pcOldTalk=.F.
\ENDIF
\pcOldSafety=SET("SAFETY")
\pcOldNotify=SET("NOTIFY")
\pcOldCollate=SET("COLLATE")
\pcOldCursor=SET("Cursor")
\pcOldError=ON("ERROR")
\SET SAFETY OFF
\SET NOTIFY OFF
\SET CURSOR OFF
\ON ERROR
\
\pfrmTermometer = Createobject("Termometer")
\pfrmTermometer.XpProgressBar.MaxVal = <<m.lnTMax>>
\pfrmTermometer.Show(2)
\
\****         ****
\**************    ****************
\lnFH=Fopen("<<Substr(m.lcDBName,Rat("\",m.lcDBName)+1)>>",2)
\If m.lnFH<0
\  Messagebox("        ."+Chr(13)+ ;
\    "  ,         "+Chr(13)+Chr(13)+ ;
\    "p.s.    ,  ",16)
\  Do RestorySet
\  Return .f.
\Endif
\Fclose(m.lnFH)
\USE <<SUBSTR(m.lcDBName,RAT("\",m.lcDBName)+1)>> EXCLUSIVE
\DELETE ALL FOR ALLTRIM(UPPER(ObjectType)) = "INDEX"
\DELETE ALL FOR ALLTRIM(UPPER(ObjectType)) = "RELATION"
\REPLACE ALL PROPERTY WITH DelPrimaryKey(PROPERTY) ;
\  FOR ALLTRIM(UPPER(ObjectType)) = "TABLE"
\PACK
\USE
\FLUSH
\
\****    ****
\CLOSE DATABASES ALL
\OPEN DATABASE <<SUBSTR(m.lcDBName,RAT("\",m.lcDBName)+1)>> EXCLUSIVE


  For lnI= 1 To m.lnColTabl
    lnT= m.lnT + 1
    lcTablePath= Upper(DBGetProp( laTableName( m.lnI ), "Table", "Path" ))
    Use ( lcTablePath ) Again Noupdate
    If Tagcount()= 0
      Use
      Loop
    Endif


\TERMOMETER_CYCLE
\****   <<laTableName[lnI]>> ****
\ IF FILE("<<STRTRAN(m.lcTablePath,'.DBF','.CDX')>>")
\   ERASE (FULLPATH("<<STRTRAN(m.lcTablePath,'.DBF','.CDX')>>"))
\ ENDIF
\ USE <<laTableName[lnI]>> EXCLUSIVE
\ SET COLLATE TO "<<Idxcollate( m.lnI )>>"
\ PACK

    For lnJ=1 To Tagcount()
      lcTagName= Proper( Tag( m.lnJ ) ) &&  
      Do Case
      Case Primary( m.lnJ ) && 
        lcTagType= 'P' &&  
      Case Candidate( m.lnJ ) && 
        lcTagType= 'C' &&  
      Case Unique( m.lnJ ) && 
        lcTagType= 'U' &&  
      Otherwise && 
        lcTagType= 'R' &&  
      Endcase

      lcTagOrder= Iif( Descending( m.lnJ ), Chr( 242 ), Chr( 241 ) )
      lcTagKey= Proper( Key( m.lnJ ) ) &&  
      lcTagFor= Proper( For( m.lnJ ) ) && FOR 


      lcIndexExpr= ''
      If m.lcTagType= 'P'  && Primary key
        If Empty( m.lcTagFor )
          lcIndexExpr= 'ALTER TABLE ' + laTableName[lnI] + ' ADD PRIMARY KEY ' + m.lcTagKey + ' TAG ' + m.lcTagName
        Else
          lcIndexExpr= 'ALTER TABLE ' + laTableName[lnI] + ' ADD PRIMARY KEY ' + m.lcTagKey + ' TAG ' + m.lcTagName + ' FOR ' + lcTagFor
        Endif
      Else  && REGULAR, UNIQUE, CANDIDATE
        lcIndexExpr= 'INDEX ON ' + m.lcTagKey + ' TAG ' + m.lcTagName + ' COMPACT'
        If ! Empty( lcTagFor )
          lcIndexExpr= m.lcIndexExpr + ' FOR ' + m.lcTagFor
        Endif
        If m.lcTagOrder= Chr( 241 )
          lcIndexExpr= m.lcIndexExpr + ' ASCENDING'
        Else
          lcIndexExpr= m.lcIndexExpr+' DESCENDING'
        Endif
        Do Case
        Case m.lcTagType= 'U'
          lcIndexExpr= m.lcIndexExpr + ' UNIQUE'
        Case m.lcTagType= 'C'
          lcIndexExpr= m.lcIndexExpr + ' CANDIDATE'
        Endcase
      Endif
\ <<Upper( m.lcIndexExpr )>>

    Endfor
  Endfor


\
\****    ****

  For lnI= 1 To m.lnColRela
    lnT= m.lnT + 1
\TERMOMETER_CYCLE
\ ALTER TABLE <<laRelaName[lnI,1]>> ADD FOREIGN KEY TAG <<laRelaName[lnI,3]>> REFERENCES <<laRelaName[lnI,2]>> TAG <<laRelaName[lnI,4]>>
\
  Endfor

\
\****       ****

  For lnI= 1 To m.lnColRela
    If ! Empty( laRelaName[m.lnI,5] )
      lnT= m.lnT + 1
\TERMOMETER_CYCLE
\ CLOSE DATABASES ALL
\ USE <<SUBSTR(m.lcDBName,RAT("\",m.lcDBName)+1)>> EXCLUSIVE
\ LOCATE FOR ALLTRIM(UPPER(ObjectType)) = "TABLE" .AND. ALLTRIM(UPPER(ObjectName)) = "<<UPPER(laRelaName[lnI,1])>>"
\ IF FOUND()
\   lnObjectID = ObjectID
\   LOCATE FOR ALLTRIM(UPPER(ObjectType)) = "RELATION" .AND. ;
\     ATC("<<laRelaName[lnI,3]>>",PROPERTY) > 0 .AND. ;
\     ATC("<<laRelaName[lnI,2]>>",PROPERTY) > 0 .AND. ;
\     ATC("<<laRelaName[lnI,4]>>",PROPERTY) > 0 .AND. ;
\     PARENTID = m.lnObjectID
\   IF FOUND()
\     REPLACE RiInfo WITH "<<UPPER(laRelaName[lnI,5])>>"
\   ELSE
\     MESSAGEBOX("  ,    ", 48)
\   ENDIF
\ ENDIF
\ USE
\
    Endif
  Endfor


  *     
\
\CLOSE DATABASES ALL
\DO RestorySet
\INKEY(0.5,'H')
\ENDFUNC
\
\****        ****
\FUNCTION DelPrimaryKey
\ LPARAMETERS lcProperty
\ LOCAL lnPoz1,lnPoz2
\ #DEFINE KOD_PRIMARY_KEY Chr(0)+Chr(0)+Chr(0)+Chr(1)+Chr(0)+Chr(20)
\ IF KOD_PRIMARY_KEY $ m.lcProperty
\   lnPoz1=AT(KOD_PRIMARY_KEY,m.lcProperty)-1
\   lnPoz2=AT(CHR(0),SUBSTR(m.lcProperty,m.lnPoz1+LEN(KOD_PRIMARY_KEY)))+m.lnPoz1+LEN(KOD_PRIMARY_KEY)-1
\   RETURN STUFF(m.lcProperty,m.lnPoz1,m.lnPoz2-m.lnPoz1+1,'')
\ ELSE
\   RETURN m.lcProperty
\ ENDIF
\ #UNDEFINE KOD_PRIMARY_KEY
\ENDFUNC
\
\****   SET  ****
\FUNCTION RestorySet
\ SET COLLATE TO (m.pcOldCollate)
\ SET NOTIFY &pcOldNotify
\ SET SAFETY &pcOldSafety
\ SET CURSOR &pcOldCursor
\ ON ERROR &pcOldError
\ IF m.pcOldTalk
\   SET TALK ON
\ ENDIF
\ENDFUNC
\
\****     ****
\Define Class Termometer As Form
\
\
\  Autocenter = .T.
\  Top = 0
\  Left = 0
\  Height = 100
\  Width = 375
\  ShowWindow = 1
\  DoCreate = .T.
\  Caption = " "
\  ControlBox = .F.
\  FontName = "MS Sans Serif"
\  FontSize = 8
\  Name = "Form1"
\
\
\  Add Object lblPercent As Label With ;
\    AutoSize = .T., ;
\    FontName = "MS Sans Serif", ;
\    FontSize = 8, ;
\    BackStyle = 0, ;
\    Height = 15, ;
\    Left = 8, ;
\    Top = 80, ;
\    Width = 34
\
\
\  Add Object XpProgressBar As XpProgressBar With ;
\    Top = 60, ;
\    Left = 8, ;
\    Width = 335, ;
\    Per_Cent = .F.
\
\
\  Procedure Init
\    This.Name = Sys(2015)
\  Endproc
\
\
\  Procedure XpProgressBar.ProgressUpdated
\    Thisform.lblPercent.Caption=" : "+Alltrim(Str(This.npercent))+"%"
\    Thisform.Refresh
\  Endproc
\
\
\Enddefine
\
\
\Define Class XpProgressBar As Container
\
\
\  Width = 183
\  Height = 16
\  BackStyle = 0
\  BorderWidth = 1
\  *-- .T. or .F.. If true, the curval value must be between 0 and 100. If false, you must provide the maxval and the curval must be less then the maxval. The progress bar was adjusted accordingly.
\  per_cent = .T.
\  *-- Used if per_cent=.F., this value was the maximum value (100%) of the curval. ie: if maxval was 500 and curval was 200, the progress bar show 40% completion.
\  maxval = 0
\  *-- The current value to be shown in the control. The control was updated automatically on assign.
\  Curval = 0
\  *-- This value was updated at run time to the current % of the progress. You can read it in the ProgressUpdated method to update a label of the current progress.
\  npercent = -1
\  Name = "progressbar"
\
\
\  Add Object externalring As Shape With ;
\    Top = 1, ;
\    Left = 1, ;
\    Height = 14, ;
\    Width = 181, ;
\    Curvature = 5, ;
\    BackColor = Rgb(255,255,255), ;
\    BorderColor = Rgb(104,104,104)
\
\
\  Add Object midlering As Shape With ;
\    Top = 2, ;
\    Left = 2, ;
\    Height = 12, ;
\    Width = 179, ;
\    Curvature = 4, ;
\    BackColor = Rgb(255,255,255), ;
\    BorderColor = Rgb(191,189,192)
\
\
\  Add Object internalring As Shape With ;
\    Top = 3, ;
\    Left = 4, ;
\    Height = 10, ;
\    Width = 176, ;
\    Curvature = 3, ;
\    BackColor = Rgb(255,255,255), ;
\    BorderColor = Rgb(239,239,239)
\
  For lnI= 1 To 25
\  Add Object ProgressPoint<<alltrim(str(m.lnI))>> As ProgressPoint With ;
\    Top = 4, ;
\    Left = <<5+((m.lnI-1)*7)>>
\
  Endfor
\
\
\  *-- automatically update the progress bar.
\  Protected Procedure curval_assign
\    Lparameters vNewVal
\    *To do: Modify this routine for the Assign method
\    This.Curval = m.vNewVal
\
\    Local nDots,i,cDot
\
\    If This.per_cent
\      This.Curval=Min(100,This.Curval)
\      This.npercent=This.Curval
\      nDots=Int(This.Curval/4)
\    Else
\      This.Curval=Min(This.maxval,This.Curval)
\      This.npercent=Int(This.Curval*100/This.maxval)
\      nDots=Int(This.npercent/4)
\    Endif
\
\    For i = 1 To 25
\      cDot="this.ProgressPoint"+Alltrim(Str(i))
\      If i > nDots
\        &cDot..Visible=.F.
\      Else
\        &cDot..Visible=.T.
\      Endif
\    Endfor
\  Endproc
\
\
\  *-- the minimal width of this object was 183 pixels. the width can be changed by increments of 25 pixels. The width was automatically adjusted to match this guideline.
\  Hidden Procedure width_assign
\    Lparameters vNewVal
\    Local nMinimalWidth,nTmpWidth,nLeftpos,nDist,i,cDot
\    nMinimalWidth=183  && hardcoded width for optimal display
\    Do Case
\    Case vNewVal < nMinimalWidth
\      This.Width=183
\    Case This.Width = nMinimalWidth
\      *nothing to do
\      This.Width=vNewVal
\    Otherwise  && > nMinimalWidth
\      nTmpWidth=vNewVal-nMinimalWidth
\      If nTmpWidth%25 > 0
\        *rounding up (base 25)
\        nTmpWidth=(Int(nTmpWidth/25)+1)*25
\      Endif
\      This.Width=nMinimalWidth+nTmpWidth
\      *initial distance between lefts of dots = 7
\      *initial width of dots = 5
\      *initial left for the first dot = 5
\      *how many times we add 25 px
\      nDist=nTmpWidth/25
\      nLeftpos=5
\      For i = 1 To 25
\        cDot="this.ProgressPoint"+Alltrim(Str(i))
\        &cDot..Width=5+nDist
\        &cDot..Left=nLeftpos
\        nLeftpos=nLeftpos+7+nDist
\      Endfor
\      This.externalring.Width=This.Width-2
\      This.midlering.Width=This.Width-4
\      This.internalring.Width=This.Width-7
\    Endcase
\  Endproc
\
\
\  Hidden Procedure npercent_assign
\    Lparameters vNewVal
\    *To do: Modify this routine for the Assign method
\    If This.npercent <> vNewVal
\      This.npercent = m.vNewVal
\      This.ProgressUpdated()
\    Endif
\  Endproc
\
\
\  Protected Procedure Init
\    This.myInit()
\    This.Width=This.Width
\    This.BorderWidth=0
\    This.Curval=This.Curval
\  Endproc
\
\
\  *-- This method was called at the beginning of the original (protected) init().
\  Procedure myInit
\  Endproc
\
\
\  *-- This method was called when the npercent value change. So it's a good place to add code that provide feedback off the current progress.
\  Procedure ProgressUpdated
\  Endproc
\
\
\Enddefine
\
\
\Define Class ProgressPoint As Container
\
\
\  Width = 5
\  Height = 7
\  BorderWidth = 0
\  Visible = .F.
\  Name = "ProgressPoint"
\
\
\  Add Object line1 As Line With ;
\    Height = 0, ;
\    Left = 0, ;
\    Top = 0, ;
\    Width = 5, ;
\    BorderColor = Rgb(171,238,171)
\
\
\  Add Object line2 As Line With ;
\    Height = 0, ;
\    Left = 0, ;
\    Top = 1, ;
\    Width = 5, ;
\    BorderColor = Rgb(125,227,125)
\
\
\  Add Object line3 As Line With ;
\    Height = 0, ;
\    Left = 0, ;
\    Top = 2, ;
\    Width = 5, ;
\    BorderColor = Rgb(77,218,80)
\
\
\  Add Object line4 As Line With ;
\    Height = 0, ;
\    Left = 0, ;
\    Top = 3, ;
\    Width = 5, ;
\    BorderColor = Rgb(45,211,49)
\
\
\  Add Object line5 As Line With ;
\    Height = 0, ;
\    Left = 0, ;
\    Top = 4, ;
\    Width = 5, ;
\    BorderColor = Rgb(66,216,69)
\
\
\  Add Object line6 As Line With ;
\    Height = 0, ;
\    Left = 0, ;
\    Top = 5, ;
\    Width = 5, ;
\    BorderColor = Rgb(117,226,119)
\
\
\  Add Object line7 As Line With ;
\    Height = 0, ;
\    Left = 0, ;
\    Top = 6, ;
\    Width = 5, ;
\    BorderColor = Rgb(142,230,144)
\
\
\  Procedure width_assign
\    Lparameters vNewVal
\    *To do: Modify this routine for the Assign method
\    This.Width = m.vNewVal
\    This.line1.Width=This.Width
\    This.line2.Width=This.Width
\    This.line3.Width=This.Width
\    This.line4.Width=This.Width
\    This.line5.Width=This.Width
\    This.line6.Width=This.Width
\    This.line7.Width=This.Width
\  Endproc
\
\
\Enddefine


  Fclose( m.lnFHOut )
  _Text= m.lnOld_Text
  Close Databases All
  Set Textmerge &lcOldTextmerge &lcOldTextmergeShow
  Cd ( m.lcOldPath )
  #UnDefine TERMOMETER_CYCLE

Endfunc
